/*                                    */
/* foobar2000 wrapper for SNESAPU.dll */
/*                                    */
/*        hereby public domain        */
/*                                    */
#pragma warning(disable : 4995)

#include "input_snesapu.hpp"
#include "script700.h"

#include "resource.h"
#define SPC_ID "SNES-SPC700 Sound File Data "
#define XID6_ID "xid6"
#define OFS_XID6 0x10200

//Sub-chunk ID's (from SNES AMP)
#define	XID6_SONG	0x01
#define	XID6_GAME	0x02
#define	XID6_ARTIST	0x03
#define	XID6_DUMPER	0x04
#define	XID6_DATE	0x05
#define	XID6_EMU	0x06
#define	XID6_CMNTS	0x07
#define	XID6_INTRO	0x30
#define	XID6_LOOP	0x31
#define	XID6_END	0x32
#define	XID6_FADE	0x33
#define	XID6_MUTE	0x34
#define	XID6_LOOPX	0x35
#define	XID6_AMP	0x36
#define	XID6_OST	0x10
#define	XID6_DISC	0x11
#define	XID6_TRACK	0x12
#define	XID6_PUB	0x13
#define	XID6_COPY	0x14

//Data types
#define	XID6_TVAL	0x00
#define	XID6_TSTR	0x01
#define	XID6_TINT	0x04

#define	XID6_EMULIST	9

// foobar2000-configurable variables
// {DBE7C79E-25AA-47e8-9561-779D26292F13}
static const GUID guid_samplerate =
{ 0xdbe7c79e, 0x25aa, 0x47e8, { 0x95, 0x61, 0x77, 0x9d, 0x26, 0x29, 0x2f, 0x13 } };
// {5DB802FB-A0EB-4b54-90FE-B57955042BED}
static const GUID guid_bitspersample =
{ 0x5db802fb, 0xa0eb, 0x4b54, { 0x90, 0xfe, 0xb5, 0x79, 0x55, 0x4, 0x2b, 0xed } };
// {6C5EB8D0-277C-4cf5-ACD1-F143D2395343}
static const GUID guid_channels =
{ 0x6c5eb8d0, 0x277c, 0x4cf5, { 0xac, 0xd1, 0xf1, 0x43, 0xd2, 0x39, 0x53, 0x43 } };
// {C77CBD5F-0158-44ae-9807-CD316B0A265D}
static const GUID guid_mixing =
{ 0xc77cbd5f, 0x158, 0x44ae, { 0x98, 0x7, 0xcd, 0x31, 0x6b, 0xa, 0x26, 0x5d } };
// {95ADC33A-B84E-4b07-B767-0D30A0E63D43}
static const GUID guid_interpolation =
{ 0x95adc33a, 0xb84e, 0x4b07, { 0xb7, 0x67, 0xd, 0x30, 0xa0, 0xe6, 0x3d, 0x43 } };
// {032D7E32-868E-41f7-97E3-8E633697CE34}
static const GUID guid_options =
{ 0x32d7e32, 0x868e, 0x41f7, { 0x97, 0xe3, 0x8e, 0x63, 0x36, 0x97, 0xce, 0x34 } };
// {16F8F107-2201-4415-8112-295AEAE27DE8}
static const GUID guid_fastseek =
{ 0x16f8f107, 0x2201, 0x4415, { 0x81, 0x12, 0x29, 0x5a, 0xea, 0xe2, 0x7d, 0xe8 } };
// {4A85C063-F697-4afc-9990-B4F106A3D548}
static const GUID guid_usespclength =
{ 0x4a85c063, 0xf697, 0x4afc, { 0x99, 0x90, 0xb4, 0xf1, 0x6, 0xa3, 0xd5, 0x48 } };
// {7F03E6DD-DF8E-49b7-A92C-7C944E9CE960}
static const GUID guid_forcelength =
{ 0x7f03e6dd, 0xdf8e, 0x49b7, { 0xa9, 0x2c, 0x7c, 0x94, 0x4e, 0x9c, 0xe9, 0x60 } };
// {51B67B9B-C10C-480c-950D-899E7CE4382E}
static const GUID guid_songlength =
{ 0x51b67b9b, 0xc10c, 0x480c, { 0x95, 0xd, 0x89, 0x9e, 0x7c, 0xe4, 0x38, 0x2e } };
// {4C6B7F2E-8B30-4bce-912A-F51746C43E7F}
static const GUID guid_fadelength =
{ 0x4c6b7f2e, 0x8b30, 0x4bce, { 0x91, 0x2a, 0xf5, 0x17, 0x46, 0xc4, 0x3e, 0x7f } };
// {21BFB1C2-AC00-472a-A0EC-B97C771475D9}
static const GUID guid_amplification =
{ 0x21bfb1c2, 0xac00, 0x472a, { 0xa0, 0xec, 0xb9, 0x7c, 0x77, 0x14, 0x75, 0xd9 } };

static cfg_int cfg_samplerate		(guid_samplerate,		32000);
static cfg_int cfg_bitspersample	(guid_bitspersample,	16);
static cfg_int cfg_channels			(guid_channels,			2);
static cfg_int cfg_mixing			(guid_mixing,			MIX_INT);
static cfg_int cfg_interpolation	(guid_interpolation,	INT_GAUSS);
static cfg_int cfg_options			(guid_options,			0);
static cfg_int cfg_fastseek			(guid_fastseek,			1);
static cfg_int cfg_usespclength		(guid_usespclength,		1);
static cfg_int cfg_forcelength		(guid_forcelength,		1);
static cfg_int cfg_songlength		(guid_songlength,		180000);
static cfg_int cfg_fadelength		(guid_fadelength,		2000);
static cfg_int cfg_amplification	(guid_amplification,	16);

#pragma pack(push, 1)


struct XID6Chk
{
    u8	id;									// Subchunk ID
    u8	type;								// Type of data
    u16	val;
};
#pragma pack(pop)

static const s8 emuList[XID6_EMULIST][12] =
{"unknown","ZSNES","Snes9x","ZST2SPC","ETC","SNEShout","ZSNES/W","Snes9xpp","SNESGT"};

void input_snesapu::try700_(const char *p_path)
{
    if (sapu.InitWork_700)
      sapu.InitWork_700();

    if (sapu.try700)
      {
          pfc::string8 s700(p_path);
          // file://?
          if (!pfc::strcmp_ex(s700, pfc::strlen_utf8("file://"), "file://", pfc::strlen_utf8("file://"))) {
              int last = s700.find_last("/");
              s700.remove_chars(0, last+1);

              pfc::stringcvt::string_ansi_from_utf8 ansi_path(s700, pfc::strlen_utf8(s700));
              sapu.try700((char*)ansi_path.get_ptr());
          }
      }
}

PFC_DECLARE_EXCEPTION(exception_snesapu_dll_using,pfc::exception,"SNESAPU.DLL is using");

bool input_snesapu::free_dll()
{
    if (!hDLL)
      return true;

    m_cs.enter();
    if (hDLL) {
        ::FreeLibrary(hDLL);
        pDLL_use = NULL;
        hDLL = NULL;
    }
    m_cs.leave();
    return true;
}

bool input_snesapu::get_dll()
{
    if (pDLL_use != NULL) {
        console::info("SNESAPU.DLL does not support multiple instances.");
        console::info("Please stop other decoding processes and try again.");
        throw exception_snesapu_dll_using();
        return false;
    }
    if (!hDLL) {
        if (load_dll() == false) {
            return false;
        }
    }
    m_cs.enter();
    pDLL_use = this;
    m_cs.leave();

    return true;
}

void input_snesapu::release_dll()
{
    if (pDLL_use == this) {
        m_cs.enter();
        pDLL_use = NULL;
        m_cs.leave();
    }
}

input_snesapu::SNESAPU_CORE input_snesapu::get_snes_core()
{
    if (!hDLL) {
        load_dll();
    }
    if (sapu.SetScript700)
      return CORE_SSDLabo;
    if (sapu.try700)
      return CORE_41568K;
    return CORE_APLHA2;
}

bool input_snesapu::load_dll()
{
    if (hDLL)
      return true;

    // attempt SNESAPU.dll load
    m_cs.enter();
    hDLL = ::uLoadLibrary("SNESAPU.DLL");
    ::ZeroMemory(&sapu, sizeof(sapu));
    if (hDLL) {
        *(void**)&sapu.GetAPUData		= (void*)GetProcAddress(hDLL, "GetAPUData");
        *(void**)&sapu.SNESAPUInfo		= (void*)GetProcAddress(hDLL, "SNESAPUInfo");
        *(void**)&sapu.ResetAPU			= (void*)GetProcAddress(hDLL, "ResetAPU");
        *(void**)&sapu.FixAPU			= (void*)GetProcAddress(hDLL, "FixAPU");
        *(void**)&sapu.LoadSPCFile		= (void*)GetProcAddress(hDLL, "LoadSPCFile");
        *(void**)&sapu.EmuAPU			= (void*)GetProcAddress(hDLL, "EmuAPU");
        *(void**)&sapu.EmuDSP			= (void*)GetProcAddress(hDLL, "EmuDSP");
        *(void**)&sapu.EmuSPC			= (void*)GetProcAddress(hDLL, "EmuSPC");
        *(void**)&sapu.SetAPUOpt		= (void*)GetProcAddress(hDLL, "SetAPUOpt");
        *(void**)&sapu.SetAPULength		= (void*)GetProcAddress(hDLL, "SetAPULength");
        *(void**)&sapu.SetDSPAmp		= (void*)GetProcAddress(hDLL, "SetDSPAmp");
        *(void**)&sapu.SetDSPReg		= (void*)GetProcAddress(hDLL, "SetDSPReg");
        *(void**)&sapu.SeekAPU			= (void*)GetProcAddress(hDLL, "SeekAPU");

        *(void**)&sapu.SetScript700		= (void*)GetProcAddress(hDLL, "SetScript700");
        *(void**)&sapu.try700			= (void*)GetProcAddress(hDLL, "try700");
        *(void**)&sapu.InitWork_700		= (void*)GetProcAddress(hDLL, "InitWork_700");

        sapu.GetAPUData(&sapu.ram, &sapu.xram, NULL, &sapu.t64Cnt,
                        &sapu.dsp, &sapu.voice, &sapu.vMMaxL, &sapu.vMMaxR);
    }
    m_cs.leave();

    if (!hDLL) {
        console::info("Could not locate SNESAPU.DLL.");
        return false;
    }

    if (sapu.SNESAPUInfo == NULL || sapu.LoadSPCFile == NULL || sapu.EmuAPU == NULL) {
        console::info("SNESAPU.DLL function lookups failed.");
    } else {
        u32	version, minimum, options;
        sapu.SNESAPUInfo(&version, &minimum, &options);

        if (version < 0x20000 || minimum > 0x20000) {
            console::info("Incompatible SNESAPU.DLL version.");
            free_dll();
            return false;
        }
    }
    return true;
}

input_snesapu::~input_snesapu()
{
    release_dll();
    if (spcfile)
      {
          delete [] spcfile;
      }
}

int input_snesapu::spc_header_num_test(char *str, int len)
{
    int	pos = 0;

    while ((pos < len) && ((str[pos] >= 0x30 && str[pos] <= 0x39) || str[pos] == '/'))
      {
          ++pos;
      }

    if (pos == len || str[pos] == 0)
      {
          return pos;
      }
    else
      {
          return -1;
      }
}

// decode_initializelengthfade_lengthKvȂ̂ŐɓǂłB
void input_snesapu::spc_header_read_pre(SPCHEAD *spchead)
{
    char spc_songlength[4] = {0};
    char spc_fadelength[6] = {0};
    if (((char*)spchead)[0xd2] == 0) {
        // songlen
        if (spchead->bin.songlen) {
            stored_songlength = spchead->bin.songlen * 1000;
        }
        // fadelen
        int fadelen = spchead->bin.fadelen[0];
        fadelen += spchead->bin.fadelen[1] << 8;
        fadelen += spchead->bin.fadelen[2] <<16;
        if (fadelen) {
            stored_fadelength  = fadelen;
        }
    } else {
        memcpy(spc_songlength, spchead->text.songlen, 3);
        memcpy(spc_fadelength, spchead->text.fadelen, 5);
        stored_songlength = atoi(spc_songlength) * 1000;
        stored_fadelength = atoi(spc_fadelength);
    }
    // clamp song lengths
    if (stored_songlength > 959000)
      {
          stored_songlength = 959000;
      }
    if (stored_fadelength > 59999)
      {
          stored_fadelength = 59999;
      }
    // decide song length
    if (stored_songlength && sapu_usespclength)
      {
          sapu_forcelength = 1;
          sapu_songlength  = stored_songlength;
          sapu_fadelength  = stored_fadelength;
      }
}

bool input_snesapu::spc_header_read(SPCHEAD *spchead, file_info &p_info)
{
    pfc::string8 spc_song;
    pfc::string8 spc_game;
    pfc::string8 spc_artist;
    pfc::string8 spc_dumper;
    pfc::string8 spc_comment;
    pfc::string8 spc_ost;
    pfc::string8 spc_ost_disc;
    pfc::string8 spc_ost_track;
    pfc::string8 spc_publisher;
    pfc::string8 spc_copylight;
    pfc::string8 spc_emu;
    pfc::string8 spc_date;

    pfc::stringcvt::string_utf8_from_ansi ansi_data(spchead->song, 32);
    spc_song.set_string(ansi_data);
    ansi_data.convert(spchead->game, 32);
    spc_game.set_string(ansi_data);
    ansi_data.convert(spchead->dumper, 16);
    spc_dumper.set_string(ansi_data);
    ansi_data.convert(spchead->comment, 32);
    spc_comment.set_string(ansi_data);

    // Discrimination text / binary format
    if (((char*)spchead)[0xd2] == 0) {
        // binary format
        if (spchead->bin.artist[0] != 0) {
            ansi_data.convert(spchead->bin.artist, 32);
            spc_artist.set_string(ansi_data);
        }
        if (spchead->bin.year) {
            ansi_data.convert(spchead->bin.artist, 32);
            spc_artist.set_string(ansi_data);
        }
        if (spchead->bin.year && spchead->bin.year <= 9999) {
            pfc::string_printf date_format("%d%c%d%c%d", spchead->bin.year,'/',spchead->bin.month,'/',spchead->bin.date);
            spc_date.set_string(date_format);
        }
        // songlen
        //			if (spchead->bin.songlen) {
        //				stored_songlength = spchead->bin.songlen;
        //			}
        // fadelen
        //			int fadelen = spchead->bin.fadelen[0];
        //			fadelen += spchead->bin.fadelen[1] << 8;
        //			fadelen += spchead->bin.fadelen[2] <<16;
        //			if (fadelen) {
        //				stored_fadelength  = fadelen;
        //			}
        // emulator
        if (spchead->bin.emulator >= 0 &&
            spchead->bin.emulator < XID6_EMULIST)
          {
              spc_emu.set_string(emuList[spchead->bin.emulator]);
          }
    } else {
        // text format
        if (spchead->text.artist[0] != 0) {
            ansi_data.convert(spchead->text.artist, 32);
            spc_artist.set_string(ansi_data);
        }
        if (spchead->text.date[0] != 0) {
            ansi_data.convert(spchead->text.date, 11);
            spc_date.set_string(ansi_data);
        }
        if (spchead->text.emulator >= 0x30 &&
            spchead->text.emulator < 0x30+XID6_EMULIST)
          {
              spc_emu.set_string(emuList[spchead->text.emulator - 0x30]);
          }
        //			memcpy(spc_songlength, spchead->text.songlen, 3);
        //			memcpy(spc_fadelength, spchead->text.fadelen, 5);
        //			stored_songlength = atoi(spc_songlength) * 1000;
        //			stored_fadelength = atoi(spc_fadelength);
    }
    // clamp song lengths
    //		if (stored_songlength > 959000)
    //		{
    //			stored_songlength = 959000;
    //		}
    //		if (stored_fadelength > 59999)
    //		{
    //			stored_fadelength = 59999;
    //		}
    // decide song length
    //		if (stored_songlength && sapu_usespclength)
    //		{
    //			sapu_forcelength = 1;
    //			sapu_songlength  = stored_songlength;
    //			sapu_fadelength  = stored_fadelength;
    //		}

    // Extended ID666
    if (spcfilelen >= 0x1020c) {
        if (::memcmp(&spcfile[OFS_XID6], XID6_ID, 4) == 0) {
            s32 hdr_size = *((u32*)&spcfile[OFS_XID6 + 4]);
            s32 remain_size = spcfilelen - (OFS_XID6+8);
            if (hdr_size > remain_size) hdr_size = remain_size;

            XID6Chk *id6 = (XID6Chk*)&spcfile[OFS_XID6+8];
            while (hdr_size > 0) {
                hdr_size -= 4;
                int length = (id6->val + 3) & ~3;
                switch (id6->id) {
                  case XID6_SONG:
                    ansi_data.convert((const char*)((&id6->val)+1), id6->val);
                    spc_song.set_string(ansi_data);
                    break;
                  case XID6_GAME:
                    ansi_data.convert((const char*)((&id6->val)+1), id6->val);
                    spc_game.set_string(ansi_data);
                    break;
                  case XID6_ARTIST:
                    ansi_data.convert((const char*)((&id6->val)+1), id6->val);
                    spc_artist.set_string(ansi_data);
                    break;
                  case XID6_PUB:
                    ansi_data.convert((const char*)((&id6->val)+1), id6->val);
                    spc_publisher.set_string(ansi_data);
                    break;
                  case XID6_OST:
                    ansi_data.convert((const char*)((&id6->val)+1), id6->val);
                    spc_ost.set_string(ansi_data);
                    break;
                  case XID6_DUMPER:
                    ansi_data.convert((const char*)((&id6->val)+1), id6->val);
                    spc_dumper.set_string(ansi_data);
                    break;
                  case XID6_CMNTS:
                    ansi_data.convert((const char*)((&id6->val)+1), id6->val);
                    spc_comment.set_string(ansi_data);
                    break;
                  case XID6_DISC:
                    {
                        pfc::string_printf disc("%d", id6->val);
                        spc_ost_disc.set_string(disc);
                    }
                    break;
                  case XID6_TRACK:
                    {
                        pfc::string_printf track("%d", id6->val >> 8);
                        spc_ost_track.set_string(track);
                    }
                    break;
                  case XID6_COPY:
                    {
                        pfc::string_printf copylight("%d", id6->val);
                        spc_copylight.set_string(copylight);
                    }
                    break;
                  case XID6_EMU:
                    if (id6->val >= 0x30 && id6->val < 0x30+XID6_EMULIST) {
                        spc_emu.add_string(emuList[id6->val - 0x30]);
                    }
                    break;
                  case XID6_DATE:
                    if (id6->val ==0) {
                        spc_date.set_string("");
                    }
                    break;
                    // Not implement yet.
                  case XID6_MUTE:
                    break;
                  case XID6_LOOPX:
                    break;
                  case XID6_AMP:
                    break;
                  case XID6_FADE:
                    break;
                  case XID6_INTRO:
                    break;
                  case XID6_LOOP:
                    break;
                  case XID6_END:
                    break;

                }
                if (id6->type != XID6_TVAL) {
                    id6 = (XID6Chk*)((s32)id6 + length);
                    hdr_size -= length;
                }
                id6++;
            }
        }
    }

    // send info to foobar2000
    {
        if (sapu_forcelength) {
            p_info.info_set_int("spc_songlength", stored_songlength / 1000);
            p_info.info_set_int("spc_fadelength", stored_fadelength);
            p_info.set_length((double)(sapu_songlength + sapu_fadelength) / 1000.0);
        }
        if (spc_song.is_empty() == false)
          {
              p_info.meta_set("TITLE", spc_song);
          }
        if (spc_game.is_empty() == false)
          {
              p_info.meta_set("ALBUM", spc_game);
          }
        if (spc_artist.is_empty() == false)
          {
              p_info.meta_set("ARTIST", spc_artist);
          }
        if (spc_dumper.is_empty() == false)
          {
              p_info.meta_set("DUMPER", spc_dumper);
          }
        if (spc_comment.is_empty() == false)
          {
              p_info.meta_set("COMMENT", spc_comment);
          }
        if (spc_date.is_empty() == false)
          {
              p_info.meta_set("DATE", spc_date);
          }
        if (spc_publisher.is_empty() == false) {
            p_info.meta_set("PUBLISHER", spc_publisher);
        }
        if (spc_copylight.is_empty() == false) {
            p_info.meta_set("COPYRIGHT", spc_copylight);
        }
        if (spc_ost.is_empty() == false) {
            p_info.meta_set("OST", spc_ost);
        }
        if (spc_ost_disc.is_empty() == false) {
            p_info.meta_set("OST_DISC", spc_ost_disc);
        }
        if (spc_ost_track.is_empty() == false) {
            p_info.meta_set("OST_TRACK", spc_ost_track);
        }
        if (spc_emu.is_empty() == false) {
            p_info.meta_set("EMULATOR", spc_emu);
        }

        p_info.info_set("codec", "SPC");
        p_info.info_set_int("samplerate", sapu_samplerate);
        p_info.info_set_int("channels", sapu_channels);
        p_info.info_set_int("bitspersample", sapu_bitspersample);
    }
    return true;
}

void input_snesapu::get_info(file_info &p_info, abort_callback &p_abort)
{
    // read info from spc
    spc_header_read(reinterpret_cast<SPCHEAD*>(spcfile), p_info);
}

void input_snesapu::open(service_ptr_t<file> p_filehint, const char * p_path, t_input_open_reason p_reason, abort_callback &p_abort)
{
    if (p_reason == input_open_info_write)
      throw exception_io_unsupported_format();

    m_file = p_filehint;
    m_path.set_string(p_path);
    input_open_file_helper(m_file, p_path, p_reason, p_abort);

    // read spc file
    spcfilelen			= (u32)m_file->get_size(p_abort);
    spcfile				= new u8[spcfilelen];
    //		if (!spcfile) return false;
    m_file->read(spcfile, spcfilelen, p_abort);

    // Check header
    if (::memcmp(spcfile, SPC_ID, 28))
      throw exception_io_unsupported_format();

    // load settings
    sapu_samplerate		= cfg_samplerate;
    sapu_bitspersample	= cfg_bitspersample;
    sapu_channels		= cfg_channels;
    sapu_mixing			= cfg_mixing;
    sapu_interpolation	= cfg_interpolation;
    sapu_options		= cfg_options;
    sapu_fastseek		= cfg_fastseek;
    sapu_forcelength	= cfg_forcelength;
    sapu_usespclength	= cfg_usespclength;
    sapu_songlength		= cfg_songlength;
    sapu_fadelength		= cfg_fadelength;

    spc_header_read_pre((SPCHEAD*)spcfile);
}

void input_snesapu::decode_initialize(unsigned int p_flags, abort_callback &p_abort)
{
    // load SNESAPU.DLL
    if (get_dll() == false) {
        return;
    }

    // send options/file to snesapu
    sapu.LoadSPCFile(spcfile);
    sapu.SetAPUOpt(sapu_mixing, sapu_channels, sapu_bitspersample, sapu_samplerate, sapu_interpolation, sapu_options);

    if (sapu.SetScript700) {
        // SSDLabo's snesapu.dll
        script700 parser;
        if (parser.load(m_path) == true) {
            void *pScript = parser.get_ptr();
            if (pScript) {
                if (sapu.SetScript700(pScript) == -1) {
                    console::info("Script700 parse error");
                }
            }
        } else {
            sapu.SetScript700(NULL);
        }
    } else {
        // 41568k's snesapu.dll
        try700_(m_path);
    }

    // allocate our output buffer
    u32 bufferlen	= (u32)(((buffer_duration * sapu_samplerate) + buffer_duration) / 1000);
    bufferlen	= bufferlen * sapu_channels * (sapu_bitspersample / 8);
    m_decode_buffer.set_size(bufferlen);

    sapu.SetDSPAmp(cfg_amplification);

    sapu_ticks = 0;
    if (sapu_forcelength) {
        sapu.SetAPULength(sapu_songlength * 64, sapu_fadelength * 64);
    }

    // if finite playtime is wanted, enable forced length
    if (p_flags & input_flag_no_looping) {
        sapu_usespclength = sapu_forcelength = 1;
    }
}

bool input_snesapu::decode_run(audio_chunk &p_chunk, abort_callback &p_abort)
{
    // decide how many samples we want from sapu
    int mswanted = buffer_duration;

    // clip samples requested if nearing song end
    if (sapu_forcelength) {
        if (sapu_ticks >= (sapu_songlength + sapu_fadelength)) {
            return false;
        }

        if ( (sapu_ticks + mswanted) > (sapu_songlength + sapu_fadelength) ) {
            mswanted = (sapu_songlength + sapu_fadelength) - sapu_ticks;
        }
    }

    //EmuAPU() wants no. of samples to render
    sapu.EmuAPU(m_decode_buffer.get_ptr(), ((mswanted * sapu_samplerate) / 1000), true);

    p_chunk.set_data_fixedpoint(
        m_decode_buffer.get_ptr(),
        ((mswanted * sapu_samplerate) / 1000) * sapu_channels * (sapu_bitspersample / 8),
        sapu_samplerate, sapu_channels ,sapu_bitspersample,
        audio_chunk::g_guess_channel_config(sapu_channels));

    sapu_ticks += mswanted;

    return true;
}

void input_snesapu::decode_seek(double p_seconds, abort_callback &p_abort)
{
    // compare desired seek pos with current pos
    u32 newpos = static_cast<u32>(p_seconds * 1000.0);

    // reset apu if necessary
	if (*sapu.t64Cnt >= newpos<<6) {
		sapu.LoadSPCFile(spcfile);
	}
    sapu.SeekAPU(((newpos<<6) - *sapu.t64Cnt), sapu_fastseek);

    sapu_ticks = newpos;
}
bool input_snesapu::decode_can_seek()
{
    // we can only seek if the song has a length
    if (sapu_forcelength) {
        return true;
    } else  {
        return false;
    }
}

static input_singletrack_factory_t<input_snesapu> g_input_snesapu_factory;

// combo populator helper

void combo_populate(HWND hwnd, int combo, const char **names, int *vals, int len, int def)
{
    int index;
    int defindex = 0;

    uSendDlgItemMessage(hwnd, combo, CB_RESETCONTENT, 0, 0);

	for (int i=0 ; i<len ; ++i) {
		index = uSendDlgItemMessageText(hwnd, combo, CB_INSERTSTRING, -1, names[i]);
		uSendDlgItemMessage(hwnd, combo, CB_SETITEMDATA, index, vals[i]);

		if (vals[i] == def) {
			defindex = i;
		}
	}
    uSendDlgItemMessage(hwnd, combo, CB_SETCURSEL, defindex, -1);
}


// combobox setting helper
#define COMBOGET(X) \
  if (HIWORD(wparam) == CBN_SELCHANGE) \
    { \
        data = uSendMessage((HWND)lparam, CB_GETCURSEL, 0, 0); \
        data = uSendMessage((HWND)lparam, CB_GETITEMDATA, data, 0); \
        if (data != CB_ERR) \
          { \
              X = data; \
          } \
    } \


// checkbox setting helpers
#define DSPCHECKGET(X) \
  if (uSendMessage((HWND)lparam, BM_GETCHECK, 0, 0) == BST_CHECKED) \
    { \
        cfg_options = cfg_options | X; \
    } \
  else if (cfg_options & X) \
    { \
        cfg_options = cfg_options - X; \
    } \

#define CHECKGET(X) \
  if (uSendMessage((HWND)lparam, BM_GETCHECK, 0, 0) == BST_CHECKED) \
    { \
        X = 1; \
    } \
  else \
    { \
        X = 0; \
    } \


// configuration window procedure
static BOOL CALLBACK ConfigProc(HWND hwnd, UINT msg, WPARAM wparam, LPARAM lparam)
{
    int data;

    switch (msg) {
      case WM_INITDIALOG:
        {
            // populate comboboxes
            const char *sampleratenames[] = {"8000","11025","16000","22050","24000","32000","44100","48000","64000","88200","96000"};
            int samplerates[] =				{ 8000,  11025,  16000,  22050,  24000,  32000,  44100,  48000,  64000,  88200,  96000};

            const char *mixingnames[] =		{"Integer",	"Float"};
            int mixingmodes[] =				{MIX_INT,	MIX_FLOAT};

            const char *internames[] =		{"None",	"Linear",	"Cubic",	"Gaussian",	"Sinc",		"Gaussian4"};
            int intermodes[] =				{INT_NONE,	INT_LINEAR,	INT_CUBIC,	INT_GAUSS,	INT_SINC,	INT_GAUSS4};

            const char *bitnames[] =		{"8","16","24","32"};
            int bitmodes[] =				{ 8,  16,  24,  32};

            const char *channames[] =		{"Mono","Stereo"};
            int chanmodes[] =				{ 1,	 2};

            const char *trickportmes[] =	{"0","1","2","3"};
            int trickportmodes[] =			{0,1,2,3};

            const char *tricktimemes[] =	{"0","1","2","147","483","647"};
            int tricktimemodes[] =			{0,1,2,147,483,647};

            combo_populate(hwnd, IDC_SAMPLERATE,	sampleratenames, samplerates, 11, cfg_samplerate);
            combo_populate(hwnd, IDC_MIXING,		mixingnames,	 mixingmodes, 2,  cfg_mixing);

            combo_populate(hwnd, IDC_BITS,			bitnames,		 bitmodes,	  4,  cfg_bitspersample);
            combo_populate(hwnd, IDC_CHANNELS,		channames,		 chanmodes,   2,  cfg_channels);

			HWND hDISPITM = GetDlgItem(hwnd, IDC_DSP_DISPITM);
			HWND hDISPITR = GetDlgItem(hwnd, IDC_DSP_DISPITR);
			HWND hDISFIR = GetDlgItem(hwnd, IDC_DSP_DISFIR);
			HWND hBASBOOST = GetDlgItem(hwnd, IDC_DSP_BASSBOOST);
			if (input_snesapu::get_snes_core() == input_snesapu::CORE_SSDLabo) {
				::uEnableWindow(hDISPITM, TRUE);
				::uEnableWindow(hDISPITR, TRUE);
				::uEnableWindow(hDISFIR, TRUE);
				::uEnableWindow(hBASBOOST, TRUE);
                combo_populate(hwnd, IDC_INTERPOLATION, internames,		 intermodes,  6,  cfg_interpolation);
            } else {
				::uEnableWindow(hDISPITM, FALSE);
				::uEnableWindow(hDISPITR, FALSE);
				::uEnableWindow(hDISFIR, FALSE);
				::uEnableWindow(hBASBOOST, FALSE);
                combo_populate(hwnd, IDC_INTERPOLATION, internames,		 intermodes,  4,  cfg_interpolation);
            }

			// populate dsp options
            int dspopts[][2] = {
                {IDC_DSP_ANALOG,	DSP_ANALOG},
                {IDC_DSP_OLDADPCM,	DSP_OLDSMP},
                {IDC_DSP_SURROUND,	DSP_SURND},
                {IDC_DSP_REVERSE,	DSP_REVERSE},
                {IDC_DSP_DISECHO,	DSP_NOECHO},
                {IDC_DSP_DISPITM,	DSP_NOPMOD},
                {IDC_DSP_DISPITR,	DSP_NOPREAD},
                {IDC_DSP_DISFIR,	DSP_NOFIR},
                {IDC_DSP_BASSBOOST,	DSP_BASS}};

			for (int i=0 ; i<9 ; ++i) {
				uSendDlgItemMessage(hwnd, dspopts[i][0], BM_SETCHECK, cfg_options & dspopts[i][1], 0);
            }

            // populate song length settings

            uSendDlgItemMessage(hwnd, IDC_FORCELENGTH,  BM_SETCHECK, cfg_forcelength, 0);
            uSendDlgItemMessage(hwnd, IDC_USESPCLENGTH,  BM_SETCHECK, cfg_usespclength, 0);

            pfc::string_printf songlen("%d", cfg_songlength.get_value());
            uSetDlgItemText(hwnd, IDC_SONGLENGTH, songlen);

            pfc::string_printf fadelen("%d", cfg_fadelength.get_value());
            uSetDlgItemText(hwnd, IDC_FADELENGTH, fadelen);

            // populate misc options
            uSendDlgItemMessage(hwnd, IDC_FASTSEEK,  BM_SETCHECK, cfg_fastseek, 0);

            HWND hSlider = GetDlgItem(hwnd, IDC_VOLUME);
            ::uSendMessage(hSlider, TBM_SETTICFREQ, 16, 0) ;
            ::uSendMessage(hSlider, TBM_SETRANGE, (WPARAM)TRUE, (LPARAM)MAKELONG(0, 255));
            ::uSendMessage(hSlider, TBM_SETPOS, (WPARAM)TRUE, (LPARAM)(cfg_amplification));
            pfc::string_printf volume("%d", cfg_amplification.get_value());
            ::uSetDlgItemText(hwnd, IDC_VOLUME_VALUE, volume);

            return 1;
        }

      case WM_COMMAND:
        {
            switch (LOWORD(wparam))
              {
                case IDC_SAMPLERATE:
                  {
                      COMBOGET(cfg_samplerate)
                        break;
                  }

                case IDC_MIXING:
                  {
                      COMBOGET(cfg_mixing)
                        break;
                  }

                case IDC_INTERPOLATION:
                  {
                      COMBOGET(cfg_interpolation)
                        break;
                  }

                case IDC_BITS:
                  {
                      COMBOGET(cfg_bitspersample)
                        break;
                  }

                case IDC_CHANNELS:
                  {
                      COMBOGET(cfg_channels)
                        break;
                  }

                case IDC_DSP_ANALOG:
                  {
                      DSPCHECKGET(DSP_ANALOG)
                        break;
                  }

                case IDC_DSP_OLDADPCM:
                  {
                      DSPCHECKGET(DSP_OLDSMP)
                        break;
                  }

                case IDC_DSP_SURROUND:
                  {
                      DSPCHECKGET(DSP_SURND)
                        break;
                  }

                case IDC_DSP_REVERSE:
                  {
                      DSPCHECKGET(DSP_REVERSE)
                        break;
                  }

                case IDC_DSP_DISECHO:
                  {
                      DSPCHECKGET(DSP_NOECHO)
                        break;
                  }
				case IDC_DSP_DISPITM:
				  {
                      DSPCHECKGET(DSP_NOPMOD)
                        break;
				  }

				case IDC_DSP_DISPITR:
				  {
                      DSPCHECKGET(DSP_NOPREAD)
                        break;
				  }

				case IDC_DSP_DISFIR:
				  {
                      DSPCHECKGET(DSP_NOFIR)
                        break;
				  }

				case IDC_DSP_BASSBOOST:
				  {
                      DSPCHECKGET(DSP_BASS)
                        break;
				  }

                case IDC_USESPCLENGTH:
                  {
                      CHECKGET(cfg_usespclength)
                        break;
                  }

                case IDC_FORCELENGTH:
                  {
                      CHECKGET(cfg_forcelength)
                        break;
                  }

                case IDC_SONGLENGTH:
                  {
                      if (HIWORD(wparam) == EN_CHANGE)
                        {
                            data = atoi(string_utf8_from_window((HWND)lparam));

                            if (data > 0)
                              {
                                  cfg_songlength = data;
                              }
                        }
                      break;
                  }

                case IDC_FADELENGTH:
                  {
                      if (HIWORD(wparam) == EN_CHANGE)
                        {
                            data = atoi(string_utf8_from_window((HWND)lparam));

                            if (data > 0)
                              {
                                  cfg_fadelength = data;
                              }
                        }
                      break;
                  }

                case IDC_FASTSEEK:
                  {
                      CHECKGET(cfg_fastseek)
                        break;
                  }
              }
        }
      case WM_HSCROLL:
        {
            switch (GetWindowLong((HWND)lparam, GWL_ID))
              {
                case IDC_VOLUME:
                  {
                      cfg_amplification = (int)SendMessage((HWND)lparam, TBM_GETPOS, 0, 0);
                      pfc::string_printf volume("%d", cfg_amplification.get_value());
                      ::uSetDlgItemText(hwnd, IDC_VOLUME_VALUE, volume);
                  }
              }
        }
    }

    return 0;
}

// {A8E61D30-B2E2-4cce-AD31-739E6CA85DF1}
static const GUID guid_snesapu_preference_page =
{ 0xa8e61d30, 0xb2e2, 0x4cce, { 0xad, 0x31, 0x73, 0x9e, 0x6c, 0xa8, 0x5d, 0xf1 } };

// our config class
class preferences_snesapu : public preferences_page
{
  public:

    HWND create(HWND parent)
      {
          return uCreateDialog(IDD_CONFIG, parent, ConfigProc);
      }

    const char * get_name()
      {
          return "SNESAPU SPC Decoder";
      }

    GUID get_guid() {
        return guid_snesapu_preference_page;
    }

    GUID get_parent_guid() {
        return guid_input;
    }

    bool reset_query() {
        return true;
    }

    void reset() {
        cfg_samplerate = 32000;
        cfg_bitspersample = 16;
        cfg_channels = 2;
        cfg_mixing = MIX_INT;
        cfg_interpolation = INT_GAUSS;
        cfg_options = 0;
        cfg_fastseek = 1;
        cfg_usespclength = 1;
        cfg_forcelength = 1;
        cfg_songlength = 180000;
        cfg_fadelength = 2000;
        cfg_amplification = 16;
    }
};

static preferences_page_factory_t<preferences_snesapu> g_preferences_snesapu_factory;

// version info

DECLARE_COMPONENT_VERSION("SNESAPU SPC Decoder",
                          "0.02",
                          "Uses SNESAPU.dll for SPC decoding.")

DECLARE_FILE_TYPE("SPC files","*.spc" );

// static member

input_snesapu *input_snesapu::pDLL_use = NULL;
HINSTANCE input_snesapu::hDLL = NULL;
critical_section input_snesapu::m_cs;
SAPUFunc input_snesapu::sapu = {0};
